/***

   $BOS7?%m%\%C%H!'#2Bf$K$h$k@QLZ$NJRIU$1(B
   
 $B<B9TJ}K!!'(B
    compile arm2
    klic -o arm2 arm2.kl1 util.kl1 machine.kl1 
    arm2

       Copyright (c) 1998  Fumio Mizoguchi 

***/

/*** Root$B%(!<%8%'%s%H(B ***/
:- agent(root).

 new :- 
    init,run.

 init :- #robotic_agent:new.
 run :- true.


/*** Robotic_agent$B%(!<%8%'%s%H(B ***/
/* $B>e0L%(!<%8%'%s%H$+$i$N%?%9%/$r2r<a$7(B          */
/* $B#2Bf$N(Brobot$B%(!<%8%'%s%H$X%3%^%s%I$rAw?.(B.      */
:- agent(robotic_agent). 

 new :-
    init,  run.

 init :-
    machine:armSimulator(Machine),
    #robot:new(robot(left,Machine,12001,12002)),
    #robot:new(robot(right,Machine,12003,12004)).

 run  :- 
    *do(left,pickup(0,300,0),[ok,C0]),
    *do(left,deliver(0,400),[C0,C1,C2,C3,C4]),
    *do(right,receive(0,400),[ok,C1,C2,C3,C5]),
    *do(right,release,[C5,C6]).


/*** robot$B%(!<%8%'%s%H(B ***/
/* $B>e0L%(!<%8%'%s%H$+$i$N%3%^%s%I$r2r<a$7(B     */
/* Socket$B%(!<%8%'%s%H$X%m%\%C%H%3%^%s%I$rAw?.(B */
:- agent(robot).
     
 new(robot(Hand,Host,OutPort,InPort)) :-
    init(Host,OutPort,InPort),
    run(Hand).

 init(Host,OutPort,InPort) :-
    #socket:new(Host,OutPort,InPort).

 run(Hand)  :- ^do(Hand,pickup(XL,YL,RL),[ok,C]) |
    *do(mp(XL,YL,70,-90,RL),[ok,C1]),
    *do(mp(XL,YL,40,-90,RL),[C1,C2]),
    *do(gc,[C2,C3]),
    *do(mp(XL,YL,70,-90,RL),[C3,C4]),
    *do(mp(0,160,371,-90,0),[C4,C]),
    run(Hand).
 run(Hand) :- ^do(Hand,release,[ok,C]) |
    *do(mp(0,350,150,-70,0),[ok,C1]),
    *do(go,[C1,C2]),
    *do(mp(0,160,371,-90,0),[C2,C]),
    run(Hand).
 run(Hand) :- ^do(Hand,deliver(X,Y),[ok,C0,C1,C2,C3]) |
    *do(mp(X,Y,400,0,0),[ok,C0]),
    *do(go,[C1,C2]),
    *do(mp(0,160,371,-90,0),[C2,C3]),
    run(Hand).
 run(Hand) :- ^do(Hand,receive(X,Y),[ok,C0,C1,C2,C3]) |
    Y1 := Y-50,
    *do(mp(X,Y1,400,0,90),[ok,_]),
    *do(mp(X,Y,400,0,90),[C0,C4]),
    *do(gc,[C4,C1]),
    *do(mp(X,Y1,400,0,90),[C2,_]),
    *do(mp(0,160,371,-90,0),[C2,C3]),
    run(Hand).


/*** Socket$B%(!<%8%'%s%H(B ***/
/* $B>e0L%(!<%8%'%s%H$+$i$N%3%^%s%I$r%m%\%C%H%7%9%F%`$XAw?.(B */
:- agent(socket).

 new(Host,OutPort,InPort) :-
    util:connect(Host,OutPort) +Out,
    util:connect(Host,InPort) +In,
    run +Out +In.

 run +Out +In:- ^do(X,[ok,OK]) |
    util:command_to_string(X,Str),
    Out <= fwrite(Str,N),
    Out <= fflush(_),
    In <= fread(4,C),                        
    util:wait_ok(C,OK),
    run +Out +In.  


