/***

         $B#D#2$K=>$C$?%m%\%F%#%C%/%(!<%8%'%s%H$NDj5ANc(B $B%W%m%0%i%`(B
         $B0\F0%m%\%C%H$X%3%^%s%I%j%9%H$r=g!9$KAw?.$9$k!%(B
         $B=i4|0LCV%N!<%I(Bn3
   
   Copyright (c) 1998  Fumio Mizoguchi 

 $B<B9TJ}K!!'(B
    compile mobile2
    klic -o mobile2 mobile2.kl1 util.kl1 mapdata.kl1 machine.kl1
    mobile2

***/

:- agent(root).

 new :- init,
	*place_robot(n3),
	run.

 init :- 
    machine:nomadServer(Machine),
    #robotic_agent:new(robot(Machine,13001,13002)).

 run :- 
    List = [move(n4)+[ok,C1],
            move(n5)+[C1,C2],
            move(room3)+[C2,C3],
            end+[C3,_]],
    *do(actionList(List)).


:- agent(robotic_agent).

 new(Robot) :- init(Robot), run(inactive).

 init(Robot) :- #nomad:new(Robot).

 run(Action) :- 
    Action = inactive,
    ^do(actionList(List)) |
    NewAction = action(List),
    run(NewAction).
 run(Action) :- Action = action([]) |
    NewAction = inactive,
    run(NewAction).
 run(Action) :-
    Action = action([Act+Com|Next]),
    Com = [ok,End] |
    *do(Act, [ok,End]),
    NewAction = action(Next),
    run(NewAction).
 run(Action) :-
    ^place_robot(Node) |
    *do(place_robot(Node), [ok,_]),
    run(Action).

:- agent(nomad).

 new(Robot) :- init(Robot), run.

 init(robot(Host, OutPort, InPort)) :-
    #socket:new(Host, OutPort, InPort).

 run :-
    ^do(move(Node), [ok,Com]) |
    mapdata:point(Node, [X,Y], _),
    *do(gotogoal(X,Y), [ok,Com]),
    run.
 run :-
    ^do(stop) |
    *do(stop,[ok,_]),
    run.
 run :-
    ^do(end, [ok,Com]) |
    *do(end,[ok,Com]).

 run :-
    ^do(place_robot(Node), [ok,_]) |
    mapdata:point(Node, [X,Y], _),
    *do(place_robot(X,Y,0,0),[ok,_]),
    run.


:- agent(socket).

 new(Host,OutPort,InPort) :-
    util:connect(Host,OutPort) +Out,
    util:connect(Host,InPort) +In,
    run +Out +In.

 run +Out +In:- ^do(X, [ok,Com]) |
    util:command_to_string(X,Str),
    Out <= fwrite(Str,N),
    Out <= fflush(_),
    In <= fread(4,C),                        
    util:wait_ok(C,Com),
    run +Out +In.  

 check(Str) :- wait(Str) |
    builtin:print(check(Str)).


