/***

   $BF14|@)8f$K$h$k6(D4:n6H%W%m%0%i%`(B
   $B0\F0%m%\%C%H$HOS7?%m%\%C%H$N6(D4:n6H(B
   nomad$B=i4|0LCV%N!<%I(Bn2
   
 $B<B9TJ}K!!'(B
    compile mobile4
    klic -o mobile4 mobile4.kl1 util.kl1 mapdata.kl1 machine.kl1
    mobile4


       Copyright (c) 1998  Fumio Mizoguchi 

***/

:- agent(root).

 new :- init,
	*place_robot(nomad, n2),
	run.

 init :- 
    machine:nomadServer(Machine1),
    machine:armSimulator(Machine2),
    #robotic_agent:new(nomad,robot(Machine1,13001,13002)),
    #robotic_agent:new(arm,  robot(Machine2,12001,12002)).

 run :- 
    Mobile = [move(room1)+[[ok],C1],
              move(n2)+[[C1,C4],C2],
              end+[[C2],_]],
    Arm    = [pickup(300,0)+[[ok],C3],
              putdown(0,300)+[[C3,C1],C4]],
    *do(nomad, actionList(Mobile)),
    *do( arm , actionList(Arm)).


:- agent(robotic_agent).

 new(Name,Robot) :- init(Name, Robot), run(Name,inactive).

 init(nomad,Robot) :- #nomad:new(Robot).
 init( arm ,Robot) :- #arm:new(Robot).

 run(Name,inactive) :- 
    ^do(Name, actionList(List)) |
    run(Name, action(List)).
 run(Name, action([])) :- run(Name, inactive).
 run(Name, action([Act+Com|Next])) :-
    Com = [[],End] |
    *do(Act, [ok,End]),
    run(Name, action(Next)).
 run(Name, action([Act+Com|Next])) :-
    Com = [[ok|Start],End] |
    NewCom = [Start, End],
    NewAction = action([Act+NewCom|Next]),
    run(Name, NewAction).
 run(Name, Action) :-
    ^place_robot(Name, Node) |
    *do(place_robot(Node), [ok,_]),
    run(Name, Action).

:- agent(nomad).

 new(Robot) :- init(Robot), run.

 init(robot(Host, OutPort, InPort)) :-
    #socket:new(Host, OutPort, InPort).

 run :-
    ^do(move(Node), [ok,Com]) |
    mapdata:point(Node, [X,Y], _),
    *do(gotogoal(X,Y), [ok,Com]),
    run.
 run :-
    ^do(stop) |
    *do(stop, [ok,_]),
    run.
 run :-
    ^do(end, [ok,Com]) |
    *do(end, [ok,Com]).
 run :-
    ^do(place_robot(Node), [ok,_]) |
    mapdata:point(Node, [X,Y], _),
    *do(place_robot(X,Y,0,0),[ok,_]),
    run.


:- agent(arm).

 new(Robot) :- init(Robot), run.

 init(robot(Host, OutPort, InPort)) :-
    #socket:new(Host, OutPort, InPort).

 run :-
    ^do(pickup(X,Y), [ok,Com]) |
    *do(mp(X,Y,70,-90,0), [ok,D1]),
    *do(mp(X,Y,30,-90,0), [D1,D2]),
    *do(gc, [D2,D3]),
    *do(mp(X,Y,70,-90,0), [D3,D4]),
    *do(mp(0,160,371,-90,0), [D4,Com]),
    run.
 run :-
    ^do(putdown(X,Y), [ok,Com]) |
    *do(mp(X,Y,70,-90,0), [ok,D1]),
    *do(mp(X,Y,30,-90,0), [D1,D2]),
    *do(go, [D2,D3]),
    *do(mp(X,Y,70,-90,0), [D3,D4]),
    *do(mp(0,160,371,-90,0), [D4,Com]),
    run.


:- agent(socket).

 new(Host,OutPort,InPort) :-
    util:connect(Host,OutPort) +Out,
    util:connect(Host,InPort) +In,
    run +Out +In.

 run +Out +In:- ^do(X, [ok,Com]) |
    util:command_to_string(X,Str),
    Out <= fwrite(Str,N),
    Out <= fflush(_),
    In <= fread(4,C),                        
    util:wait_ok(C,Com),
    run +Out +In.  

 check(Str) :- wait(Str) |
    builtin:print(check(Str)).


